// Soubor Analza2.cs
//
// azen slov podruh, tentokrt s vlastn implementac
// kontejneru
// Ve srovnn s pedchozm programem se zmnila implementace tdy Slovnk
// a pibyla implementace seznamu


using System;
using System.Collections;

using T=System.String;


class Prvek
{
	private T data;
	private Prvek dal;
	public Prvek(T _data){NastavData(_data); dal=null;}
	public T VraData(){return data;}
	public void NastavData(T _data){data = _data;}
	public Prvek VraDal(){return dal;}
	public void NastavDal(Prvek p){dal = p;}
}

class Seznam
{
	private Prvek hlava;				// Odkaz na prvn prvek seznamu
	public Seznam()	{ hlava = null;	}
	
	public void VloNaKonec(T co)		// Zaa nov prvek na konec seznamu
	{
		if(hlava == null)				// Je-li seznam przdn
		{
			hlava = new Prvek(co);
		}
		else							// Nen-li przdn
		{
			Prvek p = hlava, q = null;
			while(p != null)			// Najdi konec seznamu
			{
				q = p;					// q bude obsahovat odkaz na posledn prvek
				p = p.VraDal();
			}
			q.NastavDal(new Prvek(co));// Pipoj nov prvek
		}
	}

	public void VloNaPotek(T co)		// zaa nov prvek na potek seznamu
	{
		Prvek p = hlava;				// Ulo si odkaz na prvn prvek
		hlava = new Prvek(co);			// Vlo nov
		hlava.NastavDal(p);			// a pipoj zbytek
	}
	
	public void Vypi()					// Vypi seznam
	{
		Prvek p = hlava;
		while(p != null)
		{
			System.Console.Write(p.VraData()+" ");
			p = p.VraDal();
		}
	}

	public Prvek Najdi(T co)			// Zjisti, zda je hodnota co v seznamu
	{									// Pokud ano, vra odkaz na prvek
		Prvek p = hlava;
		while(p != null && p.VraData() != co)
		{
			p = p.VraDal();
		}
		return p;
	}

	// Implementace algoritmu tdn vbrem (selection sort)
	public void Sea()					// Sea prvky seznamu podle velikosti
	{									// od nejmenho (tedy podle abecedy)
		Prvek p = hlava, q = null, r = null;
		if(p != null)					// Je-li seznam przdn, nen co tdit
		{
			while(p.VraDal() != null)// p: Odkaz na prvn prvek seku
			{							// q: prochz sek
				q = p.VraDal();		// r: pamatuje se dosud nalezen nejmen
				r = p; 
				while(q != null)		// Projdi prvky seku
				{
					if(q.VraData().CompareTo(r.VraData()) <= 0) 
						r = q;			// Pokud najde men prevk, zapamatuj si ho
					q = q.VraDal();
				}
				T pom = r.VraData();	// Proho nejmen s prvnm
				r.NastavData(p.VraData());
				p.NastavData(pom);		// Nejmen prvek seku je nyn na svm mst,
				p = p.VraDal();		// vezmi sek zanajc o jeden prvek dl
			}
		}
	}
	
	// Odstran vechny prvky ze seznamu
	public void Vyprzdni() // Ve obstar garbage collector...
	{
		hlava = null;
	}
}


class Analyztor
{
	private const string MEZERY = " \n\r\t\v";

	public int PeskoMezery(string dek, int od)
	{
		if(od >= dek.Length){ return -1;}

		while(MEZERY.IndexOf(dek[od])>=0)
		{
			if(++od == dek.Length) {return -1;};
		}
		return od;
	}

	public void Analyzuj(string dek, Slovnk slovnk)
	{
		if(dek == "") return;
		int i = 0;
		
		System.Text.StringBuilder slovo = null;		
		i = PeskoMezery(dek, i);
		while(i >= 0)
		{
			slovo = new System.Text.StringBuilder("");
			while((i < dek.Length) && (MEZERY.IndexOf(dek[i]) == -1))		
			{
				slovo.Append(dek[i++]);
			}
			slovnk.Vlo(slovo.ToString());
			i = PeskoMezery(dek, i);
		}
	}
}

class Slovnk 
{
	private Seznam seznam = new Seznam();
	public void Vlo(string slovo)
	{
		if(seznam.Najdi(slovo) == null)
		{
			seznam.VloNaPotek(slovo);
		}
	}
	public void Vpis()
	{
		seznam.Vypi();
	}
	public void Sea()
	{
		seznam.Sea();
	}
}


public class Class1
{
	public static void Main()
	{
		Analyztor a = new Analyztor();
		Slovnk slovnk = new Slovnk();
		string dek = Console.ReadLine();
			
		while(dek != null)
		{
			dek = dek.Trim();
			a.Analyzuj(dek, slovnk); 
			dek = Console.ReadLine();
		}
		slovnk.Sea();
		slovnk.Vpis();
		//Console.Read();
	}
}
