// Soubor Konvert.cs
// tda pro pevod mezi selnmi soustavami 
//
// Peklad:
// csc /r:VV.dll fakt1.cs
// V adresi mus bt soubor vv.dll
//

using System;
using System.Text;

public class Konvertor
{
	private static string SLICE = "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ";
	private int zklad;
	public Konvertor(int zkl)
	{
		if(zkl<2) throw new Exception("Zklad men ne 2");
		if(zkl>36) throw new Exception("Zklad vt ne 36");
		zklad = zkl;
	}
	public string konvertuj(int co)
	{
		StringBuilder slo = new StringBuilder("");
		bool zporn = false;

		if(co == 0)
		{
			return "0";
		}
		if(co < 0)
		{
			zporn = true;
			co = -co;
		}
		while(co != 0)
		{
			slo.Append(SLICE[co % zklad]);
			co /= zklad;
		}
		if(zporn) slo.Append("-");
		int i = 0, j = slo.Length-1;
		while(i < j)
		{
			char pom = slo[i];
			slo[i++] = slo[j];
			slo[j--] = pom;
		}
		return slo.ToString();
	}
}

class Test
{
	static void Main()
	{
		Console.WriteLine("Zadej zklad clov soustavy (2 - 36): ");
		int z = VV.InInt();
		Konvertor K = new Konvertor(z);
		Console.WriteLine("Zadej slo, kter do n chce pevst: ");
		int co = VV.InInt();
		Console.WriteLine(K.konvertuj(co));
		//Console.Read();
	}
}