// Soubor seznam2.cs
// Seznam ze 4. kapitoly, ale s enumertorem
// Implementuje rozhran IEnumerable, take ho lze 
// pout i v pkazu foreach
// Enumertor je deklarovn jako soukrom vnitn tda, 
// kter implementuje veejn pstupn rozhran IEnumeration
// 
using System;
using System.Collections;

using T=System.String;


class Prvek
{
	private T data;
	private Prvek dal;
	public Prvek(T _data){NastavData(_data); dal=null;}
	public T VraData(){return data;}
	public void NastavData(T _data){data = _data;}
	public Prvek VraDal(){return dal;}
	public void NastavDal(Prvek p){dal = p;}
}

class Seznam: IEnumerable
{
	private Prvek hlava;				// Odkaz na prvn prvek seznamu
	private int poet = 0;
	public virtual IEnumerator GetEnumerator()
	{
		return new Seznam.Enumertor(this);
	}
	public int Poet
	{
		get{return poet;}
	}
	public Seznam()	{ hlava = null;	}
	
	public void VloNaKonec(T co)		// Zaa nov prvek na konec seznamu
	{
		if(hlava == null)				// Je-li seznam przdn
		{
			hlava = new Prvek(co);
		}
		else							// Nen-li przdn
		{
			Prvek p = hlava, q = null;
			while(p != null)			// Najdi konec seznamu
			{
				q = p;					// q bude obsahovat odkaz na posledn prvek
				p = p.VraDal();
			}
			q.NastavDal(new Prvek(co));// Pipoj nov prvek
		}
		poet++;
	}

	public void VloNaPotek(T co)		// zaa nov prvek na potek seznamu
	{
		Prvek p = hlava;				// Ulo si odkaz na prvn prvek
		hlava = new Prvek(co);			// Vlo nov
		hlava.NastavDal(p);			// a pipoj zbytek
		poet++;
	}
	
	public void Vypi()					// Vypi seznam
	{
		Prvek p = hlava;
		while(p != null)
		{
			System.Console.Write(p.VraData()+" ");
			p = p.VraDal();
		}
	}

	public Prvek Najdi(T co)			// Zjisti, zda je hodnota co v seznamu
	{									// Pokud ano, vra odkaz na prvek
		Prvek p = hlava;
		while(p != null && p.VraData() != co)
		{
			p = p.VraDal();
		}
		return p;
	}

	// Implementace algoritmu tdn vbrem (selection sort)
	public void Sea()					// Sea prvky seznamu podle velikosti
	{									// od nejmenho (tedy podle abecedy)
		Prvek p = hlava, q = null, r = null;
		if(p != null)					// Je-li seznam przdn, nen co tdit
		{
			while(p.VraDal() != null)// p: Odkaz na prvn prvek seku
			{							// q: prochz sek
				q = p.VraDal();		// r: pamatuje se dosud nalezen nejmen
				r = p; 
				while(q != null)		// Projdi prvky seku
				{
					if(q.VraData().CompareTo(r.VraData()) <= 0) 
						r = q;			// Pokud najde men prevk, zapamatuj si ho
					q = q.VraDal();
				}
				T pom = r.VraData();	// Proho nejmen s prvnm
				r.NastavData(p.VraData());
				p.NastavData(pom);		// Nejmen prvek seku je nyn na svm mst,
				p = p.VraDal();		// vezmi sek zanajc o jeden prvek dl
			}
		}
	}
	
	// Odstran vechny prvky ze seznamu
	public void Vyprzdni() // Ve obstar garbage collector...
	{
		hlava = null;
	}
	
	// Soukrom vnitn tda - implementuje IEnumerator
	private class Enumertor: IEnumerator
	{
		private Seznam seznam;				// Obsahuje odkaz na "svj" seznam
		private Prvek aktuln=null;		// a odkaz na oaktuln prvek v seznamu

		internal Enumertor(Seznam s){seznam = s;}
		public bool MoveNext()				// Zkus pejt na dal prvek
		{									// a pokud se to poda, vrt true
			if(aktuln == null) aktuln = seznam.hlava;
			else aktuln = aktuln.VraDal();
			return aktuln != null;
		}
		public void Reset(){aktuln = null;}	// Nvrat na potek
		public object Current					// Vrac data z aktulnho prvku
		{
			get
			{
				if(aktuln==null)throw new InvalidOperationException();
				return aktuln.VraData();
			}
		}
	}
}

public class Test
{
	public static void Main()
	{
		Seznam s = new Seznam();		// Vytvome seznam 
		s.VloNaKonec("Ahoj");			// a ulome do nj njak data
		s.VloNaKonec("lidi");
		s.VloNaKonec("jak");
		s.VloNaKonec("se");
		s.VloNaKonec("mte");
		IEnumerator e = s.GetEnumerator();	// vypeme data pomoc enumertoru
		while(e.MoveNext())
		{
			System.Console.Write((string)e.Current+" ");
		}
		System.Console.WriteLine();		// Vlo pedcod na nov dek

		// a pak jet jednou pomoc foreach
		foreach(string ss in s)System.Console.Write(ss+" ");

	}
}