// Soubor CPLX.CS
// Pklady petovn opertor
// Struktura cplx pedstavuje komplexn slo v algebraick reprezentaci
// Reln a imaginrn st je zpstupnna pomoc vlasnost Re, Im a Abs
// obsahuje definice opertor
// - (unrn)
// == a != (porovnn)
// +, -, *, /
// Pi pekladu vype varovn, e petiujeme opertory == a !=, ani bychom pedefinovali metody Equals()

using System;

public struct cplx
{
	double re, im;		// reln a imaginrn st
	public cplx(double _re, double _im){re = _re; im = _im;}
	public cplx(double _re):this(_re, 0){}
	public double Re
	{
		set {re = value;}
		get{return re;}
	}
	public double Im
	{
		set {im = value;}
		get{return im;}
	}
	public double Abs
	{
			get{return Math.Sqrt(Re*Re+Im*Im);}
	}
	public static cplx operator-(cplx a)
	{
		return new cplx(-a.Re, -a.Im);
	}	  
	
	public static bool operator ==(cplx a, cplx b)
	{
		return (a.Re==b.Re)&&(a.Im==b.Im);
	}
	public static bool operator !=(cplx a, cplx b)
	{
		return (a.Re!=b.Re)||(a.Im!=b.Im);
	}
	public static cplx operator+(cplx a, cplx b)
	{
		return new cplx(a.Re+b.Re, a.Im+b.Im);
	}
	public static cplx operator-(cplx a, cplx b)
	{
		return new cplx(a.Re-b.Re, a.Im-b.Im);
	}
	public static cplx operator*(cplx a, cplx b)
	{
		return new cplx(a.Re*b.Re-a.Im*b.Im, a.Re*b.Im+a.Im*b.Re);
	}
	public static cplx operator/(cplx a, cplx b)
	{
		double d = b.Abs;
		return new cplx((a.Re*b.Re+a.Im*b.Im)/d, (a.Im*b.Re-a.re*b.Im)/d);
	}

}

class Program
{
	static void Main()
	{
		cplx a = new cplx(1,1);
		cplx d = -a;
		cplx b = new cplx(1,1);
		cplx c = new cplx(1,2);
		cplx i = new cplx(0,1);
		if (c == b)
			d = new cplx(11);
		d = (a+b)*c;
		cplx e = i*i;
	}
}

