// Soubor CPLX-GO.CS
// Tot co Kap10\03\cplx2.cs, navc opertor petypovn z double na cplx
// a z cplx na Bod a indexovn ve td Bod
// Pro vt pohodl je sem okoprovna tda Bod, tda GrafickObjekt a 
// vtov typ barvy


using System;


// Vtov typ pro barvy
public enum barvy {erven, zelen, modr, bl, ern}

//spolen pedek implementuje spolen vlastnosti vdch grafickch objekt
public class GrafickObjekt			
{
	protected barvy barva;				
	protected bool nakreslen = false;

	public virtual barvy Barva		// M vlastnost barva, pi zmn barvy se pekresl
	{
		set 
		{
			barva=value;
			if (nakreslen) Nakresli();
		}
		get
		{
			return barva;
		}
	}
	public GrafickObjekt(barvy _barva){Barva=_barva;}
	public GrafickObjekt(): this(barvy.bl) {}
	public virtual void Nakresli() // "Nakresl" obecn grafick objekt
	{
		nakreslen = true;
		Console.WriteLine("GrafickObjekt, barva "+Barva);
	}
}


// Bod zdd barvu 
// Metodu Nakresli nutno pedefinovat (bod se kresl jinak ne obecn grafick objekt)
// Aby bylo mono zachzet s Bodem jako s obecnm grafickm objektem, mus bt 
// metoda Nakresli virtuln
public class Bod: GrafickObjekt 
{
	private int x, y;						// Souadnice bodu
	public int X
	{
		set{ x = value;}
		get{ return x;} 
	}
	public int Y
	{
		set{ y = value; }
		get{ return y; }
	}

	public override void Nakresli()// "Kreslen" bodu
	{			
		nakreslen = true;
		Console.WriteLine("Kreslm Bod, barva " + Barva+ ", (" + X + ", "+ Y + 
			")");
	}
	public Bod(int _x, int _y, barvy _barva): base(_barva)
	{
		X = _x;
		Y = _y;
	}

	public int this[int i]		// Indexer
	{
		set
		{
			switch(i)
			{
				case 1: X = value; break;
				case 2: Y = value; break;
				default: throw new IndexOutOfRangeException("Chyba v indexovn Bodu");
			}
		}
		get
		{
			switch(i)
			{
				case 1: return X;
				case 2: return Y;
				default: throw new IndexOutOfRangeException("Chyba v indexovn Bodu");
			}
		}
	}

}



public struct cplx
{
	double re, im;
	public cplx(double _re, double _im){re = _re; im = _im;}
	public cplx(double _re):this(_re, 0){}
	public override bool Equals(object o)
	{
		if(!this.GetType().Equals(o.GetType()))return false;
		return (Re==((cplx)o).Re)&&(Im==((cplx)o).Im);
	}
	public double Re
	{
		set {re = value;}
		get{return re;}
	}
	public double Im
	{
		set {im = value;}
		get{return im;}
	}
	public double Abs
	{
			get{return Math.Sqrt(Re*Re+Im*Im);}
	}
	public static cplx operator-(cplx a)
	{
		return new cplx(-a.Re, -a.Im);
	}	  
	
	public static bool operator ==(cplx a, cplx b)
	{
		return a.Equals(b);
	}
	public static bool operator !=(cplx a, cplx b)
	{
		return !a.Equals(b);
	}
	public static cplx operator+(cplx a, cplx b)
	{
		return new cplx(a.Re+b.Re, a.Im+b.Im);
	}
	public static cplx operator-(cplx a, cplx b)
	{
		return new cplx(a.Re-b.Re, a.Im-b.Im);
	}
	public static cplx operator*(cplx a, cplx b)
	{
		return new cplx(a.Re*b.Re-a.Im*b.Im, a.Re*b.Im+a.Im*b.Re);
	}
	public static cplx operator/(cplx a, cplx b)
	{
		double d = b.Abs;
		return new cplx((a.Re*b.Re+a.Im*b.Im)/d, (a.Im*b.Re-a.re*b.Im)/d);
	}
	public static implicit operator cplx(double x)
	{
		return new cplx(x, 0);
	}
	public static explicit operator Bod(cplx x)
	{
		return new Bod((int)x.Re, (int)x.Im,barvy.ern);
	}
	public override string  ToString()
	{
		return "("+Re+", "+Im+")";
	}
	public double this[int i]
	{
		set{if(i==1) Re=value; else Im=value;}
		get{if(i==1) return Re; else return Im;}
	}
}





class Program
{
	static void Main()
	{
		cplx a = new cplx(1,1);
		cplx d = -a;
		cplx b = new cplx(1,1);
		cplx c = new cplx(1,2);
		cplx i = new cplx(0,1);
		if (c == b)
			d = new cplx(11);
		d = (a+b)*c;
		cplx e = i*i;
		e *= 5;
		bool bbb = a.Equals(b);
		Console.WriteLine(e);
		Bod yy = (Bod)a;
		((Bod)i).Nakresli();
		Console.WriteLine(i);
		yy[2] = 321;
		yy.Nakresli();
	}

}

