// Soubor EVENT.CS
// Ukazuje deklaraci tdy pro penos informac 
// o udlosti, delegtu pro udlost
// deklaraci udlosti ve td, handleru v jin td,
// zaregistrovn udlosti a vyvoln udlosti

using System;

// Tda pro penos informac o udlosti
public class TlatkoEventArgs: EventArgs
{
	private string kdo;
	public TlatkoEventArgs(string _kdo){kdo = _kdo;}
	public string Kdo{get{return kdo;}}
}

// Delegt pro udlost
public delegate void UdlostTlatka(object zdroj, TlatkoEventArgs e);

// Tlatko  tda, kter me vyvolat udlost
public class Tlatko
{
	private string nzev;
	public Tlatko(string jmno){nzev = jmno;}
	public event UdlostTlatka stisknut;			// deklaarce udlosti
	public void Stiskni()							// Stisknut vyvol udlost
	{
		if(stisknut != null)stisknut(this, new TlatkoEventArgs(nzev));
	}

}

public class Program
{
	// Handler udlosti
	static void StiskTlatka(object zdroj, TlatkoEventArgs e)
	{
		Console.WriteLine("Nkdo stiskl tlatko "+ e.Kdo);
	}
	public static void Main()
	{
		Tlatko T1 = new Tlatko("Ano"), T2 = new Tlatko("Ne");
		T1.stisknut += new UdlostTlatka(StiskTlatka); // Registrace zjemce o udlost
		T2.Stiskni(); // To me vyvolat udlost
		T1.Stiskni();
	}
}