// Soubor CPLX3.CS
// Pklady petovn opertor
// Pro peten opertor je pouita metoda Equals()

// Struktura cplx pedstavuje komplexn slo v algebraick reprezentaci
// Reln a imaginrn st je zpstupnna pomoc vlasnost Re, Im a Abs
// obsahuje definice opertor
// - (unrn)
// == a != (porovnn)
// +, -, *, /
//
// Obsahuje tak pekrytou metodu GethashCode() a ToString() 


using System;

public struct cplx
{
	double re, im;
	public cplx(double _re, double _im){re = _re; im = _im;}
	public cplx(double _re):this(_re, 0){}
	public override bool Equals(object o)
	{
		try  
		{
			cplx c = (cplx)o;
			return c.Re == Re && c.Im == Im;
		}
		catch(Exception e)
		{
			return false;
		}
	}

	public override int GetHashCode()
	{
		return (int)Re^(int)Im;
	}

	public double Re
	{
		set {re = value;}
		get{return re;}
	}
	public double Im
	{
		set {im = value;}
		get{return im;}
	}
	public double Abs
	{
		get{return Math.Sqrt(Re*Re+Im*Im);}
	}
	public static cplx operator-(cplx a)
	{
		return new cplx(-a.Re, -a.Im);
	}	  
	
	public static bool operator ==(cplx a, cplx b)
	{
		return a.Equals(b);
	}
	public static bool operator !=(cplx a, cplx b)
	{
		return !a.Equals(b);
	}
	public static cplx operator+(cplx a, cplx b)
	{
		return new cplx(a.Re+b.Re, a.Im+b.Im);
	}
	public static cplx operator-(cplx a, cplx b)
	{
		return new cplx(a.Re-b.Re, a.Im-b.Im);
	}
	public static cplx operator*(cplx a, cplx b)
	{
		return new cplx(a.Re*b.Re-a.Im*b.Im, a.Re*b.Im+a.Im*b.Re);
	}
	public static cplx operator/(cplx a, cplx b)
	{
		double d = b.Abs;
		return new cplx((a.Re*b.Re+a.Im*b.Im)/d, (a.Im*b.Re-a.re*b.Im)/d);
	}

	public override string ToString()
	{
		return "("+Re+", "+Im+")";
	}

}

class Program
{
	static void Main()
	{
		cplx a = new cplx(1,1);
		cplx d = -a;
		cplx b = new cplx(1,1);
		cplx c = new cplx(1,2);
		cplx i = new cplx(0,1);
		if (c == b)
			d = new cplx(11);
		d = (a+b)*c;
		cplx e = i*i;
		bool bbb = a.Equals(b);
		if (a == b) Console.WriteLine("Stejn");
		Console.WriteLine(e);			// Zde se pouije ToString()
	}
}

