// Soubor DAMY.CS
// een problmu N dam (Gauss ~1850)
// Umstit na achovnici s nxn poli n dam tak, aby se navzjem
// neohroovaly.
//
// Tda eitel pouv k nalezen vech een backtracking 
// Konstruktor zkonstruuje eitele pro zadan n
// vsledek je v poli een uloen tako
// (achovnice m dky a sloupce slovny od 0 do n-1):
// - een[m] == k znamen, e dma je v m-tm sloupci v k-tm dku
//
// Metoda Bezpen() testuje, zda je dan pozice bezpen, tj. 
// zda dmu na nm umstnou nebode ohroovat jin, umstn dve
//
// NajdiDalK() najde dal ppustnou pozici dmy v danm sloupc
//
// e() najde dal een (jedno) a skon
//
// NajdiVechnaeen() najde vechna een a vype je; 
// pouv rekurzivn metodu Najdieen()
// bool NajdiDaleen(out int[]) najde dal een; vrt false, 
// pokud neexistuje. V parametru vsledek vrt odkaz na toto een.

using System;

public class eitel
{
	private readonly int n;
	private int[] een;
	int poet = 0;

	public bool NajdiDaleen(out int[] vsledek)
	{
		if(poet==0)
			vsledek = e(0);
		else
			vsledek = e(n-1);
		if(vsledek != null) poet++;
		return vsledek != null;
	}

	public void NajdiVechnaeen()
	{
		Najdieen(0);
	}

	public int Poeteen
	{
		get{ return poet;}
	}
	
	private bool Bezpen(int k, int m)// k-t dek, m-t sloupec
	{
		if(m == 0) return true;	// V prvnm sloupci lze umstit kamkoli
		bool vsledek = true;
		int j = 0;
		while(vsledek && (j < m))			// Projdi vechny pedchoz sloupce
		{
			vsledek = (een[j] != k) &&		// stejn dek?
				(een[m-j-1] != k-j-1) &&	// stejn diagonla?
				(een[m-j-1] != k+j+1);		
			if(!vsledek) return false;
			j++;
		}
		return true;
	}

	private void Vpis()
	{
		Console.Write("(");
		for(int i = 0; i < n; i++)Console.Write(een[i]+", ");
		Console.WriteLine(")");
	}

	private int NajdiDalK(int k, int m)	// Najde dal mon umstn v m-tm sloupci, zane za k-tm dkem
	{
		
		while(++k < n)
		{
			if(Bezpen(k, m)) break;
		}
		return k;							// Neuspje-li, vrt n
	}

	private int[] e(int m)			// Zane hledat dal een, ponaje m-tm sloupcem
	{
		int k;
		while(m > -1)
		{
			k = NajdiDalK(een[m], m);
			if(k < n)
			{
				een[m++]= k;
				if(m == n) return een; 
			}
			else een[m--]=-1;
		}
		return null;
	}
	
	private void Najdieen(int m)
	{
		if(m == n)
		{
			Vpis();
			poet++;
		}
		else
		{
			for(int k = 0; k < n; k++)
			{
				if(Bezpen(k,m))
				{
					een[m] = k;
					Najdieen(m+1);
				}
			}
		}
		if(m < n)een[m] = -1;
	}

	public eitel(int n)			// Konstruktor eitele pro lohu n dam
	{
		this.n = n;
		een = new int[n];
		for(int i = 0; i < n; i++) een[i] = -1;
	}
}

public class Program
{
	public static void Main()
	{
		int kolik = 8;
		eitel  = new eitel(kolik);
		int[] p = null;
		//.NajdiVechnaeen();
		while(.NajdiDaleen(out p))
		{
			Console.Write("(");
			for(int i = 0; i < kolik; i++)
				Console.Write(p[i]+", ");
			Console.WriteLine(")");
		}
	Console.WriteLine("loha m celkem "+.Poeteen + " een.");

	}
}