// Soubor VOKNO.CS
// Okno pro een problmu N dam
// Obsahuje Panel, na kter se kresl, potadlo (NumericUpDown), 
// tlatko a nabdku.
// Ukazuje zpsob kreslen do okna (zde na panel), oetovn udlost
//
// Nutno pekldat pkazem
// csc /r:damy.dll /r:dialog.dll vokno.cs

using System;
using System.Drawing;
using System.ComponentModel;
using System.Windows.Forms;
using System.Runtime.InteropServices;



public class Vokno : System.Windows.Forms.Form
{

	
	// Komponenty
	private Panel panel;	

	private MainMenu nabdka;
	private MenuItem menuHra;
	private MenuItem menuNov;
	private MenuItem menuDal;
	private MenuItem menuSepartor;
	private MenuItem menuKonec;
	private MenuItem menuNpovda;
	private MenuItem menuOProgramu;

	private Label NpisKolikDam;
	private NumericUpDown poetDam;
	private Button daleen;

	// Pomocn datov sloky
	private int kolik = 4;
	private eitel  = null;
	private int[] een = null;		
	private bool nalezeno = false;
	private const int VELIKOST_PANELU = 300; // pixel



	public Vokno()
	{
		InitializeComponent();
	}

	[DllImport("user32.dll")]
	private static extern int MessageBoxA(int okno, string npis, string titulek, int typ);

	protected override void Dispose( bool disposing )
	{
		base.Dispose( disposing );
	}

	private void InitializeComponent()
	{
		this.panel = new Panel();
		
		SuspendLayout();
		
		this.ClientSize = new Size(520, 360);
		this.Text = "Problm N dam, poet nezadn";
		this.StartPosition = FormStartPosition.CenterScreen;

		
		// Pprava panelu
		panel.BackColor = System.Drawing.Color.White;
		this.panel.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
		this.panel.Location = new System.Drawing.Point(32, 24);
		this.panel.Size = new System.Drawing.Size(VELIKOST_PANELU, VELIKOST_PANELU);

		// Pprava nabdky
		// Vytvoen poloek
		this.nabdka = new MainMenu();
		this.menuHra = new MenuItem();
		this.menuNov = new MenuItem();
		this.menuDal = new MenuItem();
		this.menuSepartor = new MenuItem();
		this.menuKonec = new MenuItem();
		this.menuNpovda = new MenuItem();
		this.menuOProgramu = new MenuItem();

		// Texty poloek
		this.menuHra.Text = "&Hra";
		this.menuNpovda.Text = "&Npovda";
		this.menuNov.Text = "&Nov hra";
		this.menuDal.Text = "&Dal";
		this.menuSepartor.Text = "-";
		this.menuKonec.Text = "&Konec";
		this.menuOProgramu.Text = "O &programu";
		
		// Propojen poloek
		this.nabdka.MenuItems.AddRange(new MenuItem[] {this.menuHra, this.menuNpovda});
		this.menuHra.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {this.menuNov, this.menuDal, this.menuSepartor, this.menuKonec});
		this.menuNpovda.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {this.menuOProgramu});

		// Pipojen nabdky k oknu
		this.Menu = this.nabdka;

		// Npis u volie potu dam:
		this.NpisKolikDam = new Label();
		this.NpisKolikDam.Location = new Point(360, 24);
		this.NpisKolikDam.Size = new Size(80, 16);
		this.NpisKolikDam.Text = "Poet dam:";
		this.NpisKolikDam.Font = new System.Drawing.Font("Microsoft Sans Serif", 10F);

		// selnk - dic prvek na uren potu dam
		this.poetDam = new NumericUpDown();
		this.poetDam.Location = new Point(448, 24);
		this.poetDam.Size = new Size(40, 20);
		this.poetDam.Maximum = new Decimal(20);
		this.poetDam.Minimum = new Decimal(4);
		this.poetDam.Value = new Decimal(4);

		// Tlatko Najdi dal een
		this.daleen = new Button();
		this.daleen.Location = new Point(360, 280);
		this.daleen.Size = new Size(144, 40);
		this.daleen.Text = "Najdi &dal een";

		// Nkter dic prvky jsou na potku nedostupn
		this.menuDal.Enabled = false;
		this.daleen.Enabled = false;
		
		// Vloen komponent do okna
		this.Controls.AddRange(new System.Windows.Forms.Control[] {this.panel, this.NpisKolikDam, this.poetDam, this.daleen});
		ResumeLayout();

		// Registrace handler udlost 
		this.menuKonec.Click += new EventHandler(this.menuKonec_Click);	// Nabdka Konec
		this.menuNov.Click += new EventHandler(this.menuNov_Click);
		this.menuDal.Click += new EventHandler(this.menuDal_Click);
			this.daleen.Click += new EventHandler(this.menuDal_Click);
		this.panel.Paint += new System.Windows.Forms.PaintEventHandler(this.panel_Paint);
		this.menuOProgramu.Click += new System.EventHandler(this.menuOProgramu_Click);
		this.Closing += new System.ComponentModel.CancelEventHandler(this.Vokno_Closing);
	}
	
	// Handlery
	
	// Nabdka Hra|Konec
	private void menuKonec_Click(object sender, System.EventArgs e)
	{
		/*if(MessageBoxA(0, "Opravdu chce skonit?", "Dotaz", (int)MessageBoxButtons.YesNo|(int)MessageBoxIcon.Question) == (int)DialogResult.Yes) 			Close();
		if(MessageBox.Show("Opravdu chce skonit?", "Dotaz", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == DialogResult.Yes) Close();
		*/
		Close();
	}
	
	// Nabdka Hra|Dal nebo tlatko Dal een
	private void menuDal_Click(object sender, System.EventArgs e)
	{
		nalezeno = .NajdiDaleen(out een);
		if(!nalezeno)
		{
			//MessageBoxA(0, "Dal een neexistuj", "To je ve", (int)MessageBoxButtons.OK|(int)MessageBoxIcon.Information);
			MessageBox.Show("Dal een neexistuj", "To je ve", MessageBoxButtons.OK, MessageBoxIcon.Information);
			this.daleen.Enabled = false;
			this.menuDal.Enabled = false;
		}
		panel.Invalidate();
		this.Text="Problm " + kolik + " dam, nalezeno " + .Poeteen + " een";
	}

	// Nabdka Hra|Nov
	private void menuNov_Click(object sender, System.EventArgs e)
	{
		kolik = (int)this.poetDam.Value;
		 = new eitel(kolik);
		this.Text = "Problm " + kolik + " dam, nalezeno " + .Poeteen + " een";
		this.daleen.Enabled = true;
		this.menuDal.Enabled = true;
		nalezeno = false;
		panel.Invalidate();
	}

	private void menuOProgramu_Click(object sender, System.EventArgs e)
	{
		OProg op = new OProg();
//		op.ShowDialog();
		op.Visible = true;
	}

	// Pekreslen panelu (zobrazen dalho een) - vyvol metoda Invalidate()
	private void panel_Paint(object sender, PaintEventArgs e)		
	{
		Graphics g = e.Graphics;
		if(nalezeno)
		{
			Pen pen = new Pen(Color.Black);
			pen.Width = 1;
			int delta = VELIKOST_PANELU/kolik;
			for(int i = 1; i < kolik; i++)
			{
				g.DrawLine(pen,0, i*delta, 360, i*delta);
				g.DrawLine(pen,i*delta, 0, i*delta, 360);
			}
			pen.Width = 5;
			pen.Color = Color.Red;
			for(int m = 0; m < kolik; m++)
			{
				g.DrawEllipse(pen, m*delta+delta/6, een[m]*delta+delta/6, 2*delta/3, 2*delta/3);
			}
		}
		else
		{
			g.Clear(Color.White);
		}
	}
	private void Vokno_Closing(object sender, System.ComponentModel.CancelEventArgs e)
	{
		if(MessageBox.Show("Opravdu chce skonit?", "Dotaz", MessageBoxButtons.YesNo, MessageBoxIcon.Question)== DialogResult.No)
			e.Cancel = true;
	}
}

class Program
{
	public static void Main()
	{
		Application.Run(new Vokno());
	}
}


